import pandas as pd
"""存放一些关于处理dataframe的工具"""
def df_row_number(df, partition_by, order_by, rank_method):
    '''给数据增加row_number，类似于Mysql的Row_number()函数'''
    global df_rn
    if rank_method == 'asc':
        df_rn = df.groupby(partition_by)[order_by].rank(method='first', ascending=True).astype(int)
    elif rank_method == 'desc':
        df_rn = df.groupby(partition_by)[order_by].rank(method='first', ascending=False).astype(int)
    return df_rn


def df_rank(df, partition_by, order_by, rank_method):
    '''给数据进行排序，类似于Mysql的rank()函数'''
    global df_rk
    if rank_method == 'asc':
        df_rk = df.groupby(partition_by)[order_by].rank(method='min', ascending=True).astype(int)
    elif rank_method == 'desc':
        df_rk = df.groupby(partition_by)[order_by].rank(method='min', ascending=False).astype(int)
    return df_rk


def df_dense_rank(df, partition_by, order_by, rank_method):
    '''给数据进行排序，类似于Mysql的dense_rank()函数'''
    global df_rk
    if rank_method == 'asc':
        df_rk = df.groupby(partition_by)[order_by].rank(method='dense', ascending=True).astype(int)
    elif rank_method == 'desc':
        df_rk = df.groupby(partition_by)[order_by].rank(method='dense', ascending=False).astype(int)
    return df_rk



def nested_iterable_to_df(iterable, columns):
    '''将可迭代结构转化为df：输入可迭代结构与想要的列名'''
    columns_list = columns.split(',')
    # print('columns_list',columns_list)
    if not all(len(columns_list) == len(item) for item in iterable):
        print(columns_list,'列名个数不匹配')
    iterable_df = pd.DataFrame(iterable, columns=columns_list)
    return iterable_df


def df_to_nested_structure(df,iterable):
    '''将df写成嵌套iterable'''
    global nested_iterable
    if iterable == 'list':
        nested_iterable = list(list(row) for index, row in df.iterrows())
    elif iterable == 'tuple':
        nested_iterable = tuple(tuple(row) for index, row in df.iterrows())
    elif iterable == 'dict':
        nested_iterable = df.to_dict()
    else:
        print('请输入\'list\'、\'tuple\'或\'dict\'')
    return nested_iterable



def df_write_to_csv(df, csv_file_name):
    '''将df写入csv，输入df和csv文件名'''
    df.to_csv(csv_file_name + '.csv', index=False)


def df_explode(df):
    '''横向炸开能炸开的数据'''
    explode_col = [col for col in df.columns if df[col].apply(lambda x:x if isinstance(x,(list,tuple,set)) else [])]
    explode_df = df.copy()
    exploded_df = explode_df.explode(explode_col)
    print(exploded_df)